' ########################################################################################
' SAPI example
' Enumerates the voices collection.
' ########################################################################################

#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "SAPIUTILS.INC"
#INCLUDE ONCE "OLE2UTILS.INC"

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN () AS LONG

   LOCAL hr AS LONG
   LOCAL pISpVoice AS IspVoice
   LOCAL pIEnumSpObjectTokens AS IEnumSpObjectTokens
   LOCAL wszCategoryId AS STRING

   LOCAL nCount AS DWORD
   LOCAL i AS DWORD
   LOCAL pISpObjectToken AS ISpObjectToken
   LOCAL celtFetched AS DWORD
   LOCAL pszValue AS DWORD

   ' Create an instance of the ISpVoice interface
   pISpVoice = NEWCOM CLSID $CLSID_SpVoice
   IF ISNOTHING(pISpVoice) THEN EXIT FUNCTION

   ' Get a reference to an enumerator for the voices collection
   ' using the helper function SpEnumTokens
   wszCategoryId = UCODE$($SPCAT_VOICES & $NUL)
   hr = SpEnumTokens(STRPTR(wszCategoryId), %NULL, %NULL, pIEnumSpObjectTokens)
   ' Parse the collection
   IF SUCCEEDED(hr) THEN
      pIEnumSpObjectTokens.GetCount(nCount)
      FOR i = 0 TO nCount - 1
         hr = pIEnumSpObjectTokens.Next(1, pISpObjectToken, celtFetched)
         IF FAILED(hr) OR celtFetched = 0 THEN EXIT FOR
         hr = SpGetDescription(pISpObjectToken, pszValue)
         IF hr = %S_OK AND pszValue <> %NULL THEN
            ? W2A_(pszValue)
            CoTaskMemFree pszValue
         END IF
         pISpObjectToken = NOTHING
      NEXT
      pIEnumSpObjectTokens = NOTHING
   END IF

   pISpVoice = NOTHING

   #IF %DEF(%PB_CC32)
      WAITKEY$
   #ENDIF

END FUNCTION
' ========================================================================================
